// Maximum de 65536

// verifier le sens des estops en bas
// verifier a ajouter le dossier et le fichier pour les erreurs de log

//20210218 verifier input   #define	inEtatEstop		1055	//	#31		//20210218 verifier input
//20210218 relaisAlimentation output 10  enlever, grer par le XPSAF

//20210329 changement de position de initFait  la fin des boucles
//20210329 modification de estopEnclancher ()
//20210330 modification filaire pour ajouter delay avant de couper alimentation relais 

// 	1)	avant de se rendre ici, il faut rouler PAL-XPSAFv1-InitAxes.c sur le thread #3 => PAL-XPSAFv1-bios.scr
// 	2)	PAL-XPSAFv1-bios.scr => PAL-Master-with XPSAF-v1.c sur le thread #1
// 	3) 	main de PAL-Master-with XPSF-v1.c lance PAL-XPSAFv1-principale.scr
//	3.1)	bouton suivant de PAL-XPSAFv1-principale.scr => PAL-XPSAFv1-choixEtage.c sur le thread #4
//	3.2) 	bouton rinit variable 1970
//	3.3) 	bouton emergency stop hmi variable 47
//	3.4)	bouton mode manuel =>	PAL -XPAFv1- pagePrincipale vers manuel.c sur le thread #5
//	3.5)	bouton dec etage demarrage, lance PAL - XPSAFv1 - DecEtageDemarrage.c sur le thread #6
//	3.6)	bouton inc etage demarrage, lance PAL - XPSAFv1 - incEtageDemarrage.c sur le thread #7
//	3.7)	bouton dec etage fin, lance PAL - XPSAFv1 - DecEtageFin.c sur le thread #6
//	3.8)	bouton inc etage fin, lance PAL - XPSAFv1 - incEtageFin.c sur le thread #7

//	De la page PAL-XPSAFv1-Sablier.scr, quand l'init (rechercher //initFin est termin on lance :
// 	4.1)	si page paire, => PAL-XPSAFv1-Page Operation paire.scr
// 	4.2)	si page impaire, => PAL-XPSAFv1-Page Operation impaire.scr

//	5)	De la page PAL- XPSAFv1 -manuel.scr
//	5.1)	Bouton "Principale" => PAL - XPSAFv1 - page manuel vers principale.c sur le thread #3
//	5.2)	Bouton "reverse"		affecte variable 53
//	5.3)	Bouton "Tapis"			affecte variable 48
//	5.4)	Bouton "Aplanisseur" 	affecte variable 49
//	5.5)	Bouton "Kicker"			affecte variable 54
//	5.6)	Bouton "Monter Z" 		affecte variable 50
//	5.7)	Bouton "Ouvrir pince"	=> PAL - XPSAFv1 - ouverturePince.c	sur le thread #6
//	5.8)	Bouton "Fermer pince"	=> PAL - XPSAFv1 - fermeturePince.c sur le thread #7
//	5.9) 	bouton "emergency stop hmi" affecte variable 47

//	SetBit lancerInit #1999,enFonctionnement #2015 et playPause #2005 dans le PAL-XPSAFv1-choixSacsOperation.c

#include "KMotionDef.h"
//#include "C:\KMotion435b\C Programs\fonctionsCalculs4Mv20200928.h"
#define TMP 10 // which spare persist to use to transfer data
#include "C:\KMotion435b\C Programs\KflopToKMotionCNCFunctions.c"

// X 		ch0     
// Y 		ch1 
// pince	ch2
// elevateur ch3		

// Configure KFLOP to service Konnect 32 Input 16 output IO board
// Board address is 0, 
// 16 Outputs are mapped to Virtual IO 48-63 (VirtualBits)
// 32 Inputs are mapped to Virtual IO 1024-1055 (VirtualBits[0])

//	in00	1024	prox sac dans pince
//	in01	1025	sensor pince ferme et HOME
//	in02	1026	X max
//	in03	1027	X home
// 	in04	1028	X min
//	in05	1029	Y max
//	in06	1030	Y home
// 	in07	1031	Y min
// 	in08	1032	optic kicker
// 	in09	1033	optic fin aplanisseur
//	in10	1034	sensor kicker ouvert fin de course
//  in11 	1035	optic fin rouleau 
//	in12	1036
//	in13	1037
//	in14	1038
//	in15	1039
//	in16	1040	estop aplanisseur
//	in17	1041	estop operateur
//	in18	1042	estop relais
//  in19	1043	sensor securite elevateur

// etat pour ls et btn pour etre a on
int lsOn1=1;
int lsOn0=0;

// dfinition des INPUTS
#define eStopPin		1042	//	#18
#define eStopHmi		47
#define	lsKicker		1032	//	#8
#define	lsAplanisseur	1033	//	#9
#define	lsElevateur		1035	//	#11
#define	lsSacPince		1024	//	#0
#define	lsPince			1025	//	#1
#define	lsRideau		1036	//	#12
#define	lsHomeElevateur		78
#define	lsMinElevateur		77
#define	lsMaxElevateur		79
#define	lsHomeX		1027	//	#3
#define	lsMinX		1028	//	#4
#define	lsMaxX		1026	//	#2
#define	lsHomeY		1030	//	#6
#define	lsMinY		1031	//	#7
#define	lsMaxY		1029	//	#5
#define	estopUtilisateur	1041	//	#17
#define	estopAplanisseur	1040	//	#16
//#define	lsSecuriteElevateur		1043	//	#19
#define	lsRideau1		1044	//	#20
#define	lsRideau2		1045	//	#21
#define resetInit	1970

#define	lsFinCourseKicker		1034	//	#10
#define	lsHomeZ			1054	//	#30
//#define	inEtatEstop		1055	//	#31		//20210218 verifier input

#define lancerInit 		1999
#define etatInit		2004
#define playPause 		2005
#define enFonctionnement 2015

#define tapis 		0	//48
#define aplanisseur	1	//49
#define enableZ		2	//50
#define reverseZ 	3	//51
#define freinZ	 	4	//52
#define reverse tapis	5	//53
#define kicker 		6	//54
#define pince 		7	//55
#define pinceFerme	8	//56
#define rouleaux 	9	//57
#define relaisAlim	10	//58
#define estopModuleReset	11	//59
//#define relaisAlim	12	//60

double positionElevateurBase = 0;

double 	largSac	=	0;
double 	hauteurSac	=	0;
double	longSac	=	0;

double 	posPalletteY	=	1;
double 	posPalletteX	=	40;

double 	largeurPalette	=	0;
double 	hauteurPalette	=	0;
double	longueurSacPalette	=	0;

double 	jeuEntrePaletteEtPince	=	20;

double originePaletteX = 0; 
double originePaletteY = 0;

double positionSacsX [10]={0,0,0,0,0,0,0,0,0,0};
double positionSacsY [10]={0,0,0,0,0,0,0,0,0,0};
double positionSacsR [10]={0,0,0,0,0,0,0,0,0,0};

double offsetPalette = 0;	//diffrence entre le z=0 (fond pince) et le dessus de la palette
double hauteurDrop	= 0;	// hauteur de drop de sac entre le z=0 (fond pince) et le dessus de la palette

int initFaitX = 0;
int initFaitY = 0;
int initFaitZ = 0;
int initFaitP = 0;
int initFaitE = 0;

int tempoVerifEStop = 0;

int etatC = 0;
int etatE = 0;
int etatA = 0;
int etatM = 0;

int etatCStatus;
int etatEStatus;
int etatAStatus;
int etatMStatus;
int snapAmpStatus;
int axeProblematiqueStatus;
int threadActiveStatus;
extern int ThreadActive;

int etatFeedHold = 0;

int axeX = 0;
int axeY = 1;
int axePince = 2;
int axeElevateur = 3;

int etatEStopHmi	= 2;

int etatVerifier = 2;

int Answer;	

int snapAmpStatus;

char strTempo[30];	
int intTempo;

static double StartTime;
static double StartTimeKicker;
static double StartTimeEtat300;
static double StartTimeEtat600;

static double StartTimeChariot400;

int numRangee = 0;		// adresse 2000
int numSac = 0;			
int nbRangeeMax = 0;	// adresse 2010
int sacFutur = 0;

long gapMonterX = 2000;  // ce que va remonter pour effectuer l'init
long gapEntreSwitchHomeEtHomeX	= 10000;//15000;//16000;
long position1X = 0;

long gapMonterY = 2000;  // ce que va remonter pour effectuer l'init
long gapEntreSwitchHomeEtHomeY	= -6315;//-3443;//-4935;//-6000;
long position1Y = 0;


long gapMonterElevateur = 5000;  // ce que va remonter pour effectuer l'init
long gapEntreSwitchHomeEtHomeElevateur	= 18000;//20000;
long position1Elevateur = 0;

long gapMonterPince = 10000;  // ce que va remonter pour effectuer l'init

						//definition   quadra	gearbox		ratio poulie
float ratioDegrePince	= 1024        *4 * 		30* 		2 ;
//long ratioDegrePince	= 245760; // 1024 *4 * 30(ration gearbox) * 2(ratio poulie)
long positionPinceHome	=	0; // simon
long positionPince0		=	0;
long positionPince90	=	0;	//ratioDegrePince * 90/360; 	//61440;
long positionPince180	=	0;	//ratioDegrePince * 180/360;	//122880;
long positionPince270	=	0;	//ratioDegrePince * 270/360;	//184320;

long gapEntreSwitchHomeEtHomePince	= 8900;//10400;  //+1500/ 35 * ratio / 360 (35 degre) simon
long position1Pince = 0;

			     //gearbox   quadra  definition      dents pitch
//float ratioX	=	10     * 4 *       1024      / ( 24 *0.5);	// ratio encodeur/pouce
float ratioX	=	3392.1325;  // ajuster sur 40 pouces mecaniquement (theorique 3413.33)
long positionAAteindreX = 0;	

			     //gearbox   quadra  definition      dents pitch (mm)  transfere en pouce
float ratioY	=	15     * 4 *       1024      / (( 40  * 5)/25.4);	// ratio encodeur/pouce
long positionAAteindreY = 0;	

			     //gearbox   quadra  definition      dents pitch
//float ratioZ	=	60     * 4 *       1024      / ( 10 *   1);	// ratio encodeur/pouce
float ratioZ = 356 / 42.5;		// 187 count pour 44.75 pouces
long positionAAteindreZ = 0;	
long positionAAteindreZ2 = 0;	
long gapEntreSwitchHomeEtHomeZ	= 190*2;
float positionAAteindreZPo=0;

int positionBasseRamassage = 0;
				// ancien 19.5
			     //gearbox   quadra  definition      dents pitch 
//float ratioE	=	15      * 4 *       1024      / ( 17 * 0.5);	// ratio encodeur/pouce
float ratioE	=	7228.23529;	// calculer et verifier mecaniquement
long positionAAteindreE = 0;	
float positionAAteindreEPo = 0;
long positionAAteindreEMilieu = 0;
long positionAAteindreEMilieu2 = 0;
float positionAAteindreEMilieuPo = 0;
float positionAAteindreEMilieuPo2 = 0;

	int ec1 = 1994; //;	adresse des sacs en cours
	int ec2 = 1995; //
	int ec3 = 1996; //
	int ec4 = 1997; //
	int ec5 = 1998; //
	
	// adresse du choix des sacs 1984, 1985, 1986, 1987 et 1988

	double positionCalculee = 0;

	int etatPlay = 0;
	
	int	checkDoneFinPalette = 0;		

#define LOW_BIT  63 // This output drives Cap low

	int checkReadyElevateur = 0;

	int lastEstop[4]={0,0,0,0};
	int lastSolidEstop[4]={0,0,0,0};
	int countEstop[4]={0,0,0,0};
	int bitInputEstop[4]={0,0,0,0};

	int lastZ[2]={0,0};
	int lastSolidZ[2]={0,0};
	int countZ[2]={0,0};
	int bitInputZ[2]={0,0};

	int lastLimit[12]={0,0,0,0,0,0,0,0,0,0,0,0};
	int lastSolidLimit[12]={0,0,0,0,0,0,0,0,0,0,0,0};
	int countLimit[12]={0,0,0,0,0,0,0,0,0,0,0,0};
	int bitInputLimit[12]={0,0,0,0,0,0,0,0,0,0,0,0};

	int konnectOut[16]={48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63};

int etatMoveZ = 0;
int posDemZ = 0;

#define QA 72	// define to which IO bits the AB signals are connected 
#define QB 73	

int BitA,Change1=0,Change2=0, DiffX2;
int PosNoWrap, NewPosZ, PosZ=0, wraps;

//int etatEstop = 0;

double jeuRamassageSac = 0;
double offsetElevateurPalette	= 0;
float hauteurRamassageMinimumPo = 0;
float positionAAteindreZetElevateurPo	= 0;

//#define DBTIME 300

// Function  Function	Function	Function  Function	Function	Function  Function	Function

void ecrire4Bits (int num , int add)
{
	int restant=0;	
	int restantAvant=0;
	
	if((num >=0)&&(num<16))
	{
		ClearBit(add);
		ClearBit(add+1);
		ClearBit(add+2);
		ClearBit(add+3);
		
		restant = num;
		
		restantAvant = restant;
		restant = restant - 8;	
		
		if(restant >= 0)
		{
			SetBit(add+3);
		}else
		{
			restant=restantAvant;
		}		

		restantAvant = restant;
		restant = restant - 4;	
		
		if(restant >= 0)
		{
			SetBit(add+2);
		}else
		{
			restant=restantAvant;
		}			
		restantAvant = restant;
		restant = restant - 2;	
		
		if(restant >= 0)
		{
			SetBit(add+1);
		}else
		{
			restant=restantAvant;
		}	
		restant = restant - 1;	
		
		if(restant >= 0)
		{
			SetBit(add);
		}
	}
}
int lire4Bits (int add)
{
	int retour=0;
	if(ReadBit(add)==1){retour=retour+1;}
	if(ReadBit(add+1)==1){retour=retour+2;}
	if(ReadBit(add+2)==1){retour=retour+4;}
	if(ReadBit(add+3)==1){retour=retour+8;}	
	return retour;		
}


void bougeZ(void)
{
	SetBit(konnectOut[freinZ]);	
	//Delay_sec(0.1);
	SetBit(konnectOut[enableZ]);		
}

void upZ (void)
{
	ClearBit(konnectOut[reverseZ]);	
	bougeZ();
}

void downZ (void)
{
	SetBit(konnectOut[reverseZ]);	
	bougeZ();
}

void disableZ (int choixDisableZ) // 1 c'est avec reset position et stop frein
{
	ClearBit(konnectOut[enableZ]);	
	Delay_sec(0.5);		
	
	if(choixDisableZ==1)
	{
		ClearBit(konnectOut[freinZ]);	
		Change1=0;
		Change2=0;
		PosZ=gapEntreSwitchHomeEtHomeZ;	
		ch7->Position=PosZ;
	}
}

void initZ (void) 
{
	Change1=0;
	Change2=0;
	PosZ=0;	
	ch7->Position=PosZ;
	
	downZ ();
	if(ReadBit(lsHomeZ) == lsOn1) { //lsHomeZOn
		downZ ();		
		while ((ReadBit(lsHomeZ) == lsOn1)||(ReadBit(eStopPin)==0)) ; //lsHomeZOn
		disableZ(1);	
	}
	else {
		upZ ();
		while ((ReadBit(lsHomeZ) != lsOn1)||(ReadBit(eStopPin)==0))  ; 	//lsHomeZOn
		disableZ(0);	
		downZ ();			
		while ((ReadBit(lsHomeZ) == lsOn1)||(ReadBit(eStopPin)==0))  ;		//lsHomeZOn
		disableZ(1);
	}
		
	if(ReadBit(eStopPin)==0){	//  vrifier le sens pour tre en dfaut
		tempoVerifEStop = 99;			
		estopEnclenche(tempoVerifEStop);		
	}else{	
		initFaitZ = 1;
	}
}

void moveZ (int positionDemandeeZ)
{
	int deadbandZ = 3;
	
	if ((positionDemandeeZ>(NewPosZ+deadbandZ))||(positionDemandeeZ<(NewPosZ-deadbandZ)))
	{
		posDemZ = positionDemandeeZ ;
		if(positionDemandeeZ > NewPosZ)
		{
			etatMoveZ = 1;
			upZ ();	
		}else{
			etatMoveZ = 1;
			downZ ();		
		}
	}
}

void changementRangee(void)
{	
	numRangee = numRangee + 1;
	ecrire4Bits (numRangee , 2000);
	if (ReadBit(2000)==1)  
	{ 
		ScreenScript("SScript:PAL-XPSAFv1-Page Operation impaire.scr");
	} 
	else 
	{ 
		ScreenScript("SScript:PAL-XPSAFv1-Page Operation paire.scr");
	}			
	sprintf(strTempo,"Operation - Rangee %d",numRangee);
	DROLabel(1000, 160, strTempo);				
}	

void verifierSacFutur(void)
{
	sacFutur = 0;
	
	if(ReadBit(1988)==0)
	{
		sacFutur = 5;
	}
	if(ReadBit(1987)==0)
	{
		sacFutur = 4;
	}
	if(ReadBit(1986)==0)
	{
		sacFutur = 3;
	}
	if(ReadBit(1985)==0)
	{
		sacFutur = 2;
	}

}

void verifierSacEnCours(void)
{
	numSac = 0;
	if(ReadBit(ec1)==1)
	{
		numSac = 1;
	}
	if(ReadBit(ec2)==1)
	{
		numSac = 2;
	}
	if(ReadBit(ec3)==1)
	{
		numSac = 3;
	}
	if(ReadBit(ec4)==1)
	{
		numSac = 4;
	}
	if(ReadBit(ec5)==1)
	{
		numSac = 5;
	}
}

void verifierProchainSac(void)
{	
	
	int i;
	SetBit(1984+numSac-1);
	
	ClearBit(1994+numSac-1);
	
	if(numSac == 5)
	{			
		for(i=1984;i<1989;i++)
		{
			ClearBit(i);
		}
		SetBit(1994);
		if(numRangee >= nbRangeeMax)
		{
			// palette fini
			
			// remettre la machine  0 ( 4 axes + Z)
			//Axe Z  HOME (en haut)				
			moveZ(gapEntreSwitchHomeEtHomeZ);				
				
			//elevateur  HOME (bas)
			MoveAtVel(3,0,ch3->Vel);	// elevateur					
								
			//Axe X  HOME ( gauche)
			MoveAtVel(0,0,ch0->Vel);	// X				
				
			//Axe Y  HOME (au fond)
			MoveAtVel(1,0,ch1->Vel);	// Y
				
			//Axe C  HOME
			MoveAtVel(2,positionPinceHome,ch2->Vel);	// Pince						
			
			checkDoneFinPalette = 1;

			
			
		}else{
			for(i=1984;i<1989;i++)
			{
				ClearBit(i);
			}
			SetBit(1994);
			changementRangee();		
			// on change de rangee
		}
	}else{
				
		verifierSacFutur();
		if (sacFutur == 0)  // prochaine etage
		{
			// on change de rangee
			for(i=1984;i<1989;i++)
			{
				ClearBit(i);
			}
			SetBit(1994);
			changementRangee();
		}else{
			SetBit(1994+sacFutur-1);
			// on continue avec le prochain sacs
		}			
	}
	verifierSacEnCours();
}

/*
void initElevateur (void)
{	
	int axeNumber	= 3;
	ch3->Position = 0; 	
	ch3->Dest = 0; 	
	
	EnableAxis(axeNumber);
	Delay_sec(1);
	
	if(ReadBit(lsHomeElevateur) == lsOn0) { //lsHomeElevateurOn
		Jog(axeNumber,10000);
		while ((ReadBit(lsHomeElevateur) == lsOn0)||(ReadBit(eStopPin)==0))  ; //lsHomeElevateurOn
	} else {
		Jog(axeNumber,-20000);        
		while ((ReadBit(lsHomeElevateur) == lsOn1)||(ReadBit(eStopPin)==0))  ; 	//lsHomeElevateurOff
	}

	position1Elevateur = ch3->Position;	
	
	Jog(axeNumber,10000);
	while ((ch3->Position<=(position1Elevateur+gapMonterElevateur))||(ReadBit(eStopPin)==0))  ; 
	
	Jog(axeNumber,-10000);
	while ((ReadBit(lsHomeElevateur) == lsOn1)||(ReadBit(eStopPin)==0))  ; //lsHomeElevateurOff
	
	Jog(axeNumber,0);		      // stop
	Delay_sec(1);
	DisableAxis(axeNumber);
	ch3->Position = gapEntreSwitchHomeEtHomeElevateur; 	
	ch3->Dest = gapEntreSwitchHomeEtHomeElevateur; 		
	
	EnableAxis(axeNumber);
	Delay_sec(1);
	MoveAtVel(axeNumber, 0, ch3->Vel);		


	if(ReadBit(eStopPin)==0){	//  vrifier le sens pour tre en dfaut
		tempoVerifEStop = 99;			
		estopEnclenche(tempoVerifEStop);		
	}else{	
		initFaitE = 1;
	}
}

void initPince (void)
{	
	int axeNumber	= 2;
	ch2->Position = 0; 	
	ch2->Dest = 0; 	
	// faut absolument fermer la pince ici
	SetBit(konnectOut[pinceFerme]);	
	Delay_sec(0.5);
	ClearBit(konnectOut[pinceFerme]);	
		
	EnableAxis(axeNumber);
	Delay_sec(1);
	
	if(ReadBit(lsPince) == lsOn0) { //lsPinceOn
		Jog(axeNumber,10000);
		while ((ReadBit(lsPince) == lsOn0)||(ReadBit(eStopPin)==0)) ; //lsPinceOn
	} else {
		Jog(axeNumber,-40000);        
		while ((ReadBit(lsPince) == lsOn1)||(ReadBit(eStopPin)==0)) ; 	//lsPinceOff
	}

	position1Pince = ch2->Position;	

	
	Jog(axeNumber,10000);
	while ((ch2->Position<=(position1Pince+gapMonterPince))||(ReadBit(eStopPin)==0)) ; 
	
	Jog(axeNumber,-10000);
	while ((ReadBit(lsPince) == lsOn1)||(ReadBit(eStopPin)==0)) ; //lsPinceOff
	
	Jog(axeNumber,0);		      // stop
	Delay_sec(1);
	DisableAxis(axeNumber);
	ch2->Position = gapEntreSwitchHomeEtHomePince; 	
	ch2->Dest = gapEntreSwitchHomeEtHomePince; 		
	
	EnableAxis(axeNumber);
	Delay_sec(1);
	MoveAtVel(axeNumber,positionPinceHome, ch2->Vel);
	while((!CheckDone(axeNumber))||(ReadBit(eStopPin)==0));	
	
	SetBit(konnectOut[pince]);	
	Delay_sec(0.5);
	ClearBit(konnectOut[pince]);	
	

	if(ReadBit(eStopPin)==0){	//  vrifier le sens pour tre en dfaut
		tempoVerifEStop = 99;			
		estopEnclenche(tempoVerifEStop);		
	}else{	
		initFaitP = 1;	
	}	
}

void initX (void) 
{	
	int axeNumber = 0;
	ch0->Position = 0; 	
	ch0->Dest = 0; 		
	EnableAxis(axeNumber);
	Delay_sec(1);
	
	if(ReadBit(lsHomeX) == lsOn1) { //lsHomeXOn
		Jog(axeNumber,5000);//10000
		while ((ReadBit(lsHomeX) == lsOn1)||(ReadBit(eStopPin)==0)) ; //lsHomeXOn
	} else {
		Jog(axeNumber,-40000);        
		while ((ReadBit(lsHomeX) == lsOn0)||(ReadBit(eStopPin)==0)) ; 	//lsHomeXOff
	}

	position1X = ch0->Position;	// CHANGER CHANGER CHANGER CHANGER CHANGER			

	
	Jog(axeNumber,5000);//10000
	while ((ch0->Position<=(position1X+gapMonterX))||(ReadBit(eStopPin)==0)) ; // CHANGER CHANGER CHANGER CHANGER CHANGER			
	
	Jog(axeNumber,-1500);
	while ((ReadBit(lsHomeX) == lsOn0)||(ReadBit(eStopPin)==0)) ; //lsHomeXOff
	
	Jog(axeNumber,0);		      // stop
	Delay_sec(1);
	DisableAxis(axeNumber);
	ch0->Position = gapEntreSwitchHomeEtHomeX; 	// CHANGER CHANGER CHANGER CHANGER CHANGER			
	ch0->Dest = gapEntreSwitchHomeEtHomeX; 		// CHANGER CHANGER CHANGER CHANGER CHANGER			
	
	EnableAxis(axeNumber);
	Delay_sec(1);
	MoveAtVel(axeNumber, 0, ch0->Vel/2);	// CHANGER CHANGER CHANGER CHANGER CHANGER			
	while((!CheckDone(axeNumber))||(ReadBit(eStopPin)==0));


	if(ReadBit(eStopPin)==0){	//  vrifier le sens pour tre en dfaut
		tempoVerifEStop = 99;			
		estopEnclenche(tempoVerifEStop);		
	}else{	
		initFaitX = 1;	
	}		
}
void initY (void) 
{
		
	int axeNumber = 1;
	ch1->Position = 0; 	
	ch1->Dest = 0; 	
	EnableAxis(axeNumber);
	Delay_sec(1);
	
	if(ReadBit(lsHomeY) == lsOn1) { //lsHomeYOn
		Jog(axeNumber,10000);
		while ((ReadBit(lsHomeY) == lsOn1)||(ReadBit(eStopPin)==0)) ; //lsHomeYOn
	} else {
		Jog(axeNumber,-40000);        
		while ((ReadBit(lsHomeY) == lsOn0)||(ReadBit(eStopPin)==0)) ; 	//lsHomeYOff
	}

	position1Y = ch1->Position;	// CHANGER CHANGER CHANGER CHANGER CHANGER			

	
	Jog(axeNumber,10000);
	while ((ch1->Position<=(position1Y+gapMonterY))||(ReadBit(eStopPin)==0)) ; // CHANGER CHANGER CHANGER CHANGER CHANGER			
	
	Jog(axeNumber,-2000);
	while ((ReadBit(lsHomeY) == lsOn0)||(ReadBit(eStopPin)==0)) ; //lsHomeYOff
	
	Jog(axeNumber,0);		      // stop
	Delay_sec(1);
	DisableAxis(axeNumber);
	ch1->Position = gapEntreSwitchHomeEtHomeY; 	// CHANGER CHANGER CHANGER CHANGER CHANGER			
	ch1->Dest = gapEntreSwitchHomeEtHomeY; 		// CHANGER CHANGER CHANGER CHANGER CHANGER			
	
	EnableAxis(axeNumber);
	Delay_sec(1);
	MoveAtVel(axeNumber, 0, ch1->Vel);	// CHANGER CHANGER CHANGER CHANGER CHANGER				
	while((!CheckDone(axeNumber))||(ReadBit(eStopPin)==0));


	if(ReadBit(eStopPin)==0){	//  vrifier le sens pour tre en dfaut
		tempoVerifEStop = 99;			
		estopEnclenche(tempoVerifEStop);		
	}else{	
		initFaitY = 1;	
	}		
}
*/
void calculPositionsZetE(void)
{
		positionAAteindreZetElevateurPo	= numRangee*hauteurSac + hauteurDrop;
		
				positionAAteindreZPo = (positionAAteindreZetElevateurPo+offsetPalette);
				
				if(positionAAteindreZPo < 0)
				{
					positionAAteindreZPo = 0;
				}
				
				positionAAteindreZ = positionAAteindreZPo *ratioZ;
				
				positionAAteindreZ2 = positionAAteindreZ;
				
				if(positionAAteindreZ2 < 0)
				{
					positionAAteindreZ2 = 0;
				}
				
				if(positionAAteindreZ < positionBasseRamassage)
				{
					positionAAteindreZ = positionBasseRamassage;
				}														

			if (positionAAteindreZetElevateurPo < hauteurRamassageMinimumPo)
			{
				positionAAteindreEPo = hauteurRamassageMinimumPo- offsetElevateurPalette - hauteurSac ;
			}else{
				positionAAteindreEPo = positionAAteindreZetElevateurPo - offsetElevateurPalette - hauteurSac ;
			}				

			positionAAteindreE = positionAAteindreEPo * ratioE;		

			positionAAteindreEMilieuPo = positionAAteindreEPo  - jeuRamassageSac ;
			positionAAteindreEMilieuPo2 = positionAAteindreEPo - 1.5  ;  //- jeuRamassageSac + hauteurSac
	
			positionAAteindreEMilieu = positionAAteindreEMilieuPo * ratioE;	
			positionAAteindreEMilieu2 = positionAAteindreEMilieuPo2 * ratioE;	
			
			if(positionAAteindreEMilieu < 0)
			{
				positionAAteindreEMilieu = 0;
			}
			
            if(positionAAteindreEMilieu2 < 0)
			{
				positionAAteindreEMilieu2 = 0;
			}
}


void calculPositions(void)
{
		largSac	=	15.5; // 16
		hauteurSac	=	4.5;
		longSac	=	23.5; // 24
		
		largeurPalette	=	40;
		hauteurPalette	=	6;
		longueurSacPalette	=	48;
		
		positionElevateurBase = 110000;	// par rapport au Z () et hauteur sac 5pouces
		
		positionBasseRamassage = 0;	// position du Z pour ramasser de base
		
		offsetPalette = -19.076;	//diffrence entre le z=0 (fond pince) et le dessus de la palette
		hauteurDrop	= 12;	// hauteur de drop de sac entre le z=0 (fond pince) et le dessus de la palette
		
		jeuRamassageSac = 8;
		offsetElevateurPalette	= 9.294;		
			
		originePaletteX = 29.316 + .5;	
		originePaletteY = -8.874 + .5;	
	
		positionPinceHome	=	-1000; //-1500 angle elevateur  simon 
		positionPince90	=		ratioDegrePince * 90/360; 	
		positionPince180	=	ratioDegrePince * 180/360;	
		//positionPince270	=	ratioDegrePince * 270/360;	
		positionPince270	=	ratioDegrePince * -90/360;	
	
		positionSacsX[0]= largSac*1/2;			// X #1
		positionSacsX[1]= largSac*1/2;			// X #2
		positionSacsX[2]= largSac+longSac*1/2 ;	// X #3
		positionSacsX[3]= largSac+longSac*1/2 ;	// X #4
		positionSacsX[4]= largSac+longSac*1/2 ;	// X #5
		
		positionSacsY[0]=longSac*1/2;			// Y #1		
		positionSacsY[1]=longSac*3/2;			// Y #2		
		positionSacsY[2]=largSac*1/2;			// Y #3		
		positionSacsY[3]=largSac*5/2;			// Y #4		
		positionSacsY[4]=largSac*3/2;			// Y #5

		positionSacsY[5]=longSac*1/2;			// Y #1		
		positionSacsY[6]=longSac*3/2;			// Y #2		
		positionSacsY[7]=largSac*1/2;			// Y #3		
		positionSacsY[8]=largSac*5/2;			// Y #4		
		positionSacsY[9]=largSac*3/2;			// Y #5

		positionSacsR[0]=positionPince180;			// Rotation #1		
		positionSacsR[1]=positionPince0;			// Rotation #2		
		positionSacsR[2]=positionPince270;			// Rotation #3		
		positionSacsR[3]=positionPince270;			// Rotation #4		
		positionSacsR[4]=positionPince270;			// Rotation #5

		positionSacsX[5]= longSac +largSac*1/2;	// X miroir #1		
		positionSacsX[6]= longSac +largSac*1/2;	// X miroir #2		
		positionSacsX[7]= longSac*1/2;			// X miroir #3		
		positionSacsX[8]= longSac*1/2;			// X miroir #4		
		positionSacsX[9]= longSac*1/2;			// X miroir #5

		positionSacsR[5]=positionPince180;			// Rotation miroir #1		
		positionSacsR[6]=positionPince0;			// Rotation miroir #2		
		positionSacsR[7]=positionPince90;			// Rotation miroir #3		
		positionSacsR[8]=positionPince90;			// Rotation miroir #4		
		positionSacsR[9]=positionPince90;			// Rotation miroir #5		
	
		hauteurRamassageMinimumPo = offsetElevateurPalette + 2* hauteurSac + jeuRamassageSac ;
		positionBasseRamassage =(hauteurRamassageMinimumPo+offsetPalette)*ratioZ;

		calculPositionsZetE();		
}

void encodeurZ (void)
{
		//WaitNextTimeSlice();
		
		// convert quadrature to 2 bit binary
		BitA = ReadBit(QA);   
		PosNoWrap = (ReadBit(QB) ^ BitA) | (BitA<<1);

		// Diff between expected position based on average of two prev deltas
		// and position with no wraps.  (Keep as X2 to avoid division by 2)
		
		DiffX2 = 2*(PosZ-PosNoWrap) + (Change2+Change1);
		
		// Calc quadrature wraparounds to bring Diff nearest zero
		// offset by 128 wraps to avoid requiring floor()
		wraps = ((DiffX2+1028)>>3)-128;
		
		// factor in the quadrature wraparounds
		NewPosZ = PosNoWrap + (wraps<<2);

		Change2 = Change1;
		Change1 = NewPosZ - PosZ;
		PosZ = NewPosZ;	
		ch7->Position=PosZ;
}

void verifierFinDeplacementZ (void)
{
		if(ReadBit(konnectOut[reverseZ])==1) // descend
		{
			if(posDemZ >= NewPosZ)
			{
				etatMoveZ =0;
				ClearBit(konnectOut[enableZ]);	
				//Delay_sec(0.3);			
				ClearBit(konnectOut[freinZ]);					
			}			
		}else{   // monte
			if(posDemZ  <= NewPosZ)
			{
				etatMoveZ =0;
				ClearBit(konnectOut[enableZ]);	
				//Delay_sec(0.3);			
				ClearBit(konnectOut[freinZ]);					
			}
		}	
	
	
}

void enregistrerErreur ()
{
	FILE *f; /// yes, log
	f=fopen("c:\\KMotion435b\\documents4M_PAL\\errorLog\\PAL-erreursLog.txt","at"); // open in append mode
	fprintf(f,"Axe: %d ; ThreadActive: %d ; etatC: %d ; etatE: %d ; etatA: %d ; etatM: %d \n",axeProblematiqueStatus,threadActiveStatus,etatCStatus,etatEStatus,etatAStatus,etatMStatus);
	fprintf(f,"Fault: %d ; Over Current 0: %d ; Over Current 1: %d ; Over Temp 0: %d ; Over Temp 1: %d ; Fan: %d \n",(snapAmpStatus>>0)&1,(snapAmpStatus>>1)&1,(snapAmpStatus>>2)&1,(snapAmpStatus>>3)&1,(snapAmpStatus>>4)&1,(snapAmpStatus>>5)&1);
	fclose(f);
}

void viderBufferDeplacementsAxes ()
{
	MoveAtVel(0, ch0->Position, ch0->Vel);	// X
	MoveAtVel(1, ch1->Position, ch1->Vel);	// Y
	MoveAtVel(2,ch2->Position,ch2->Vel);	// Pince
	MoveAtVel(3,ch3->Position,ch3->Vel);	// lvateurs

	ResumeCoordinatedMotion();
}
void estopEnclenche(int choixErreurAfficher)
{
	StopCoordinatedMotion();	
	
	etatC = 0;
	etatE = 0;
	etatA = 0;
	etatM = 0;

	ClearBit(konnectOut[tapis]);
	ClearBit(konnectOut[aplanisseur]);
	ClearBit(konnectOut[enableZ]);
	ClearBit(konnectOut[freinZ]);  // verifier sens 
	ClearBit(konnectOut[rouleaux]);	
		
	//Delay_sec(1);				
	
	DisableAxis(0);
	DisableAxis(1);
	DisableAxis(2);
	DisableAxis(3);
	
	//Delay_sec(0.1);	
	Delay_sec(2);	
	
	ch0->Dest=ch0->Position;
	ch1->Dest=ch1->Position;
	ch2->Dest=ch2->Position;
	ch3->Dest=ch3->Position;
	
	ClearBit(konnectOut[relaisAlim]);	
	
	initFaitZ = 0;
	
	ScreenScript("SScript:PAL-XPSAFv1-principale.scr");	
	
	switch (choixErreurAfficher)
	{
		case -1:
			Answer = MsgBox("Fin de la palette :)",MB_OK|MB_ICONEXCLAMATION);		
		break;		
		case 0:
			Answer = MsgBox("Erreur Axe X",MB_OK|MB_ICONEXCLAMATION);
			enregistrerErreur();			
		break;
		case 1:
			Answer = MsgBox("Erreur Axe Y",MB_OK|MB_ICONEXCLAMATION);
			enregistrerErreur();
		break;
		case 2:
			Answer = MsgBox("Erreur Axe Pince",MB_OK|MB_ICONEXCLAMATION);
			enregistrerErreur();
		break;
		case 3:
			Answer = MsgBox("Erreur Axe Elevateur",MB_OK|MB_ICONEXCLAMATION);
			enregistrerErreur();
		break;

		case 16:
			Answer = MsgBox("Estop de l'aplanisseur enclench !",MB_OK|MB_ICONEXCLAMATION);
		break;

		case 17:
			Answer = MsgBox("Estop de l'utilisateur enclench !",MB_OK|MB_ICONEXCLAMATION);
		break;
		
		case 20:
			Answer = MsgBox("Rideau #20 enclanch !",MB_OK|MB_ICONEXCLAMATION);
		break;	

		case 21:
			Answer = MsgBox("Rideau #21 enclanch !",MB_OK|MB_ICONEXCLAMATION);
		break;	

		case 47:
			Answer = MsgBox("EStop du HMI enclanch !",MB_OK|MB_ICONEXCLAMATION);
		break;	

		default:
			Answer = MsgBox("Module estop a renclanch !",MB_OK|MB_ICONEXCLAMATION);
		break;
	}
	

}
/*
void estopEnclenche(int choixErreurAfficher)
{
	StopCoordinatedMotion();
	etatFeedHold = 1;	
	
	etatC = 0;
	etatE = 0;
	etatA = 0;
	etatM = 0;

	int i;
	for(i=0;i<16;i++)
	{
		ClearBit(konnectOut[i]);
	}

	
	
	Delay_sec(1);				
	
	DisableAxis(0);
	DisableAxis(1);
	DisableAxis(2);
	DisableAxis(3);
	
	Delay_sec(0.1);	
	
	initFaitZ = 0;
	
	ScreenScript("SScript:PAL-XPSAFv1-principale.scr");	
	
	switch (choixErreurAfficher)
	{
		case -1:
			Answer = MsgBox("Fin de la palette :)",MB_OK|MB_ICONEXCLAMATION);		
		break;		
		case 0:
			Answer = MsgBox("Erreur Axe X",MB_OK|MB_ICONEXCLAMATION);
			enregistrerErreur();			
		break;
		case 1:
			Answer = MsgBox("Erreur Axe Y",MB_OK|MB_ICONEXCLAMATION);
			enregistrerErreur();
		break;
		case 2:
			Answer = MsgBox("Erreur Axe Pince",MB_OK|MB_ICONEXCLAMATION);
			enregistrerErreur();
		break;
		case 3:
			Answer = MsgBox("Erreur Axe Elevateur",MB_OK|MB_ICONEXCLAMATION);
			enregistrerErreur();
		break;

		case 16:
			Answer = MsgBox("Estop de l'aplanisseur enclench !",MB_OK|MB_ICONEXCLAMATION);
		break;

		case 17:
			Answer = MsgBox("Estop de l'utilisateur enclench !",MB_OK|MB_ICONEXCLAMATION);
		break;

		case 18:
			Answer = MsgBox("Module Estop enclench !",MB_OK|MB_ICONEXCLAMATION);
		break;		
		
		case 20:
			Answer = MsgBox("Rideau Bas enclanch !",MB_OK|MB_ICONEXCLAMATION);
		break;	

		case 21:
			Answer = MsgBox("Rideau Haut enclanch !",MB_OK|MB_ICONEXCLAMATION);
		break;	
		
		case 99:
			Answer = MsgBox("Arret lors de l'initialisation !",MB_OK|MB_ICONEXCLAMATION);
		break;			
		//default:
		//break;
	}
	
	
	
	ResumeCoordinatedMotion();
	etatFeedHold = 0;	
}
*/
void resetEtat(void)
{
	if(etatM != 0){
		etatC = 0;
		etatE = 0;
		etatA = 0;
		etatM = 0;	
		printf ( "Reset etat\n");	
	}
}

void gChariot(void)
{
	int i = 0;
	int j = 0;
	
	switch (etatC)
	{
		case 1:
			etatC = 400;			
			//printf ( "etatC : %d\n", etatC); 

			//ici on lance le mouvement XYC
			if(ReadBit(2000)==1)	// rangee impaire
			{
				i = 5;
			}else{
				i = 0;
			}
			
			j = numSac-1;

			positionAAteindreX = (originePaletteX+positionSacsX[i+j])*ratioX;
			positionAAteindreY = (originePaletteY+positionSacsY[i+j])*ratioY;
			
			MoveAtVel(0, positionAAteindreX, ch0->Vel);	// X
			MoveAtVel(1, positionAAteindreY, ch1->Vel);	// Y
			MoveAtVel(2,positionSacsR[i+j],ch2->Vel);	// Pince
		break;
		
		case 400:					
			if((CheckDone(0))&&(CheckDone(1))&&(CheckDone(2)))
			{
				moveZ(positionAAteindreZ2);	
				etatC = 410;				
			}
		break;
		
		case 410:
			if(etatMoveZ == 0) 
			{
				etatC = 420;				
				SetBit(konnectOut[pince]);  // ouvre la pince				
				StartTimeChariot400	=	Time_sec();						
			}
		break;

		case 420:
			if(Time_sec() > (StartTimeChariot400 + 0.3)) 
			{
				ClearBit(konnectOut[pince]); 
				moveZ(positionAAteindreZ);
				etatC = 500;
	
			}
		break;
		case 500:
			if(etatMoveZ == 0)  
			{										
				if(	checkReadyElevateur == 1 )// condition pour dplacement XYP pret pour lev
				{
				//moveZ(positionBasseRamassage);	// * rangee et hauteur minimale
				MoveAtVel(0, 0, ch0->Vel);	// X
				MoveAtVel(1, 0, ch1->Vel);	// Y
				MoveAtVel(2,positionPinceHome,ch2->Vel);	// Pince								
				}
				verifierProchainSac();
				etatC = 0;					
			}
		break;
		
	}
}

void gElevateur(void)
{	
	switch (etatE)
	{
		case 1:
			etatE = 100;	
			//printf ( "etatE : %d\n", etatE); 	

			SetBit(konnectOut[tapis]);	
			SetBit(konnectOut[rouleaux]);				
		break;
		
		case 100:
			if(ReadBit(lsElevateur)==lsOn1)	//1027	lsElevateurOn
			{
				etatE = 110;					
								//printf ( "etatE : %d  et etatA : %d\n", etatE,etatA); 
				
				ClearBit(konnectOut[tapis]);	
				ClearBit(konnectOut[rouleaux]);		
				  
				//checkReadyElevateur = 1;// condition pour dplacement XYP pret pour lev
				
				etatA = 1;
				
			}
		break;
		
		case 110:
			if(etatC == 0) 
			{	
				calculPositionsZetE();															
				moveZ(positionAAteindreZ);	// * rangee et hauteur minimale				
				etatE = 120;											
			}
		break;
		
		case 120:
			if(etatMoveZ == 0)
			{
				MoveAtVel(0, 0, ch0->Vel);	// X
				MoveAtVel(1, 0, ch1->Vel);	// Y
				MoveAtVel(2,positionPinceHome,ch2->Vel);	// Pince	
				etatE = 190;											
			}
		break;
			
		
		case 190:
			if(etatMoveZ ==0)
			{						
				MoveAtVel(3,positionAAteindreEMilieu,ch3->Vel);	// Pince				
				etatE = 200;				
			}			
		break;		
		case 200:
			if((CheckDone(0))&&(CheckDone(1))&&(CheckDone(2))&&(etatMoveZ ==0))
			{
				checkReadyElevateur = 0;// condition pour dplacement XYP pret pour lev
													
				MoveAtVel(3,positionAAteindreE,ch3->Vel);	// Pince				
				etatE = 300;				
			}			
		break;
		
		case 300:
			if(CheckDone(3))
			{
				SetBit(konnectOut[pinceFerme]);
				StartTimeEtat300 = Time_sec();	
				etatE = 400;
			}		
		break;
		
		case 400:
			if(Time_sec() > (StartTimeEtat300 + 0.3)) 
			{
				ClearBit(konnectOut[pinceFerme]);
				//MoveAtVel(3,0,ch3->Vel);	// elevateur				
				MoveAtVel(3,positionAAteindreEMilieu2,ch3->Vel);	// elevateur dessant			
				etatE = 410;
			}
		break;
		
		case 410:
			if(CheckDone(3))
			{
				checkReadyElevateur = 1;// condition pour dplacement XYP pret pour lev		
				etatC = 1;	
				MoveAtVel(3,0,ch3->Vel);	// elevateur
				etatE = 500;				
			}
		break;

		case 500:
			if(CheckDone(3))
			{		
				etatE = 0;	
				//printf ( "etatE  : %d  et etatC : %d\n", etatE, etatC); 				
			}		
		break;		
		
	}

}

void gAplanisseur(void)
{
	switch (etatA)
	{
		case 1: // attente d'un sac
			if(ReadBit(lsKicker )==lsOn1)	//lsKickerOn
			{
				etatA = 10;
				StartTimeEtat600 = Time_sec();
			}						
		break;		

		case 10:
			if(Time_sec() > (StartTimeEtat600 + 1.5)) // devrait le remplacer par fin de mouvement simonn
			{
				etatA = 100;	
				//printf ( "etatA : %d  : sac present dans kicker\n", etatA); 	

				SetBit(konnectOut[kicker]);	
				StartTimeKicker = Time_sec();
				
				SetBit(konnectOut[tapis]);
				SetBit(konnectOut[aplanisseur]);								
			}

		break;

		case 100:
			if(Time_sec() > (StartTimeKicker + 1.5))
			{				
				etatA = 300;	
				//printf ( "etatA : %d et attend kicker 1025\n", etatA); 				
				ClearBit(konnectOut[kicker]);				
			}
		break;
		
		case 300:
			if(ReadBit(lsAplanisseur)==lsOn1)	//1026	lsAplanisseurOn
			{
				etatA = 400;	
				//printf ( "etatA : %d\n", etatA); 	
				
				ClearBit(konnectOut[tapis]);
				ClearBit(konnectOut[aplanisseur]);						
			}
		break;
		
		case 400:
			if(etatE == 0) 
			{
					etatE = 1;
					//printf ( "etatE : %d\n", etatE);									
			}
		break;
		
	}
}

void g20191120(void) 
{
	switch (etatM)
	{
		case 0:
			if(ReadBit(lancerInit )==1)
			{
				etatM = 10;
				ClearBit(lancerInit );			
			}			
		break;

		case 10:
		
		//	if(ReadBit(lsKicker )==lsKickerOn)
		//	{
		//		etatM = 20;
		//		printf ( "etatM : %d\n", etatM); 
		//		Answer = MsgBox("Enlever le sac dans le kicker",MB_OK|MB_ICONEXCLAMATION);														
		//	}else{
				etatM = 30;
				//printf ( "etatM : %d\n", etatM); 						
			//}			
		break;
		
		case 20:
			if (Answer == IDOK){
				etatM = 0;
				ScreenScript("SScript:PAL-XPSAFv1-principale.scr");		
			}
		break;
		
		case 30:
			if(ReadBit(lsAplanisseur)==lsOn1)//lsAplanisseurOn
			{
				etatM = 40;
				//printf ( "etatM : %d\n", etatM); 
				Answer = MsgBox("Enlever le sac dans l'aplanniseur",MB_OK|MB_ICONEXCLAMATION);														
			}else{
				etatM = 50;
				//printf ( "etatM : %d\n", etatM); 						
			}			
		break;
		
		case 40:
			if (Answer == IDOK){
				etatM = 0;
				ScreenScript("SScript:PAL-XPSAFv1-principale.scr");		
			}
		break;
		
		case 50:
			if(ReadBit(lsElevateur)==lsOn1)//lsElevateurOn
			{
				etatM = 60;
				//printf ( "etatM : %d\n", etatM); 
				Answer = MsgBox("Enlever le sac dans l'elevateur",MB_OK|MB_ICONEXCLAMATION);														
			}else{
				etatM = 70;
				//printf ( "etatM : %d\n", etatM); 						
			}			
		break;
		
		case 60:
			if (Answer == IDOK){
				etatM = 0;
				ScreenScript("SScript:PAL-XPSAFv1-principale.scr");		
			}
		break;		
		
		case 70:
		
			if(ReadBit(lsSacPince)==lsOn1)//lsSacPinceOn
			{
				etatM = 80;				
				Answer = MsgBox("Enlever le sac dans la pince",MB_OK|MB_ICONEXCLAMATION);														
			}else{				
				etatM = 90;				
				
				etatPlay = 0;				
				
				SetBit(konnectOut[relaisAlim]);	
			
				viderBufferDeplacementsAxes ();
				
				initZ();								
				/*
				if(ReadBit(etatInit)==0)
				{
					initZ();								
				}else{
					moveZ(gapEntreSwitchHomeEtHomeZ);
				}
				*/
				/*
				if(initFaitZ == 0)
				{
					initZ();								
				}else{
					moveZ(gapEntreSwitchHomeEtHomeZ);
				}
				//Axe Z  HOME (en haut)
				
				
				//elevateur  HOME (bas)
				if(initFaitE == 0)
				{
					initElevateur();								
				}else{
					ch3->Dest=ch3->Position;
					EnableAxis(3);
					MoveAtVel(3,0,ch3->Vel);	// elevateur	
				}							
				
				
				//Axe X  HOME ( gauche)
				if(initFaitX == 0)
				{
					initX();								
				}else{
					ch0->Dest=ch0->Position;
					EnableAxis(0);					
					MoveAtVel(0,0,ch0->Vel);	// X
				}
				
				//Axe Y  HOME (au fond)
				if(initFaitY == 0)
				{
					initY();								
				}else{
					ch1->Dest=ch1->Position;
					EnableAxis(1);									
					MoveAtVel(1,0,ch1->Vel);	// Y
				}

				//Axe C  HOME
				if(initFaitP == 0)
				{
					initPince();								
				}else{
					ch2->Dest=ch2->Position;
					EnableAxis(2);					
					MoveAtVel(2,positionPinceHome,ch2->Vel);	// Pince
				}
				
				SetBit(konnectOut[pince]);
				Delay_sec(0.3);
				ClearBit(konnectOut[pince]);
				*/

				//etatEstop = 0;
				
				//on part le timer Time_sec
				StartTime = Time_sec();			
				
				etatC = 0;
				etatA = 0;
				etatE = 0;	
			}									
				
		break;
	
		case 80:
		//Answer = MsgBox("case 80",MB_OK|MB_ICONEXCLAMATION);	
			if (Answer == IDOK){
				etatM = 0;
				ScreenScript("SScript:PAL-XPSAFv1-principale.scr");		
			}
		break;	
		
		case 90:
		//initFin
			//if machine finit le home, i.e. les 5 dplacements
			if(Time_sec() > (StartTime + 2.0))
			{
				//Answer = MsgBox("case 90 if",MB_OK|MB_ICONEXCLAMATION);	
				
				//moveZ(gapEntreSwitchHomeEtHomeZ);	
				
				if(ReadBit(etatInit)==1)				
				{
					etatM = 110;	
					
					//PosZ = ch7->Position;
					
					moveZ(gapEntreSwitchHomeEtHomeZ);	
					
					ch3->Dest=ch3->Position;
					EnableAxis(3);
					MoveAtVel(3,0,ch3->Vel);	// elevateur	
					
					ch0->Dest=ch0->Position;
					EnableAxis(0);					
					MoveAtVel(0,0,ch0->Vel);	// X
					
					ch1->Dest=ch1->Position;
					EnableAxis(1);									
					MoveAtVel(1,0,ch1->Vel);	// Y
					
					ch2->Dest=ch2->Position;
					EnableAxis(2);					
					MoveAtVel(2,positionPinceHome,ch2->Vel);	// Pince		

					SetBit(konnectOut[pince]);
					Delay_sec(0.3);
					ClearBit(konnectOut[pince]);			
					

			
				
					numRangee = lire4Bits (2000);								

					verifierSacEnCours();						
				
					nbRangeeMax = lire4Bits (2010);
				
					if (ReadBit(2000)==1)  
					{ 
						ScreenScript("SScript:PAL-XPSAFv1-Page Operation impaire.scr");
					} 
					else 
					{ 
						ScreenScript("SScript:PAL-XPSAFv1-Page Operation paire.scr");
					}	

					sprintf(strTempo,"Operation - Rangee %d",numRangee);
					DROLabel(1000, 160, strTempo);							

				}		
			}else  // on vrifie si cela a pris trop de temps
			{	
				//Answer = MsgBox("case 90 else",MB_OK|MB_ICONEXCLAMATION);	
				if(Time_sec() > (StartTime + 30.0))
				{
					etatM = 100;
					//printf ( "etatM : %d\n", etatM); 
					Answer = MsgBox("Probleme avec un des mouvements",MB_OK|MB_ICONEXCLAMATION);																		
				}
			}
		break;

		case 100:
			if (Answer == IDOK){
				etatM = 0;
				ScreenScript("SScript:PAL-XPSAFv1-principale.scr");		
			}
		break;	
		
		case 110:
			if(ReadBit(playPause)==lsOn0){//btnPlayPauseAPlay
				etatM = 1;					
				etatA = 1;	
					
			}
		break;			
		

		default:
			// pas de default
		break;
	}
}

void verifModuleEstop()
{
	if(ReadBit(eStopPin)==0){	//  vrifier le sens pour tre en dfaut
		tempoVerifEStop = 18;
		
		if(ReadBit(estopAplanisseur)==0){	//  vrifier le sens pour tre en dfaut
			tempoVerifEStop = 16;	
		}
		if(ReadBit(estopUtilisateur)==0){	//  vrifier le sens pour tre en dfaut
			tempoVerifEStop = 17;			
		}			
		if(ReadBit(lsRideau1)==1){	//  vrifier le sens pour tre en dfaut
			tempoVerifEStop = 20;						
		}			
		if(ReadBit(lsRideau2)==1){	//  vrifier le sens pour tre en dfaut
			tempoVerifEStop = 21;						
		}		
		
		estopEnclenche(tempoVerifEStop);			
	}	
/*
			if(ReadBit(eStopPin)==0){	//  vrifier le sens pour tre en dfaut
				tempoVerifEStop = 18;
				estopEnclenche(tempoVerifEStop);			
			}	
			
			if(ReadBit(estopAplanisseur)==0){	//  vrifier le sens pour tre en dfaut
				tempoVerifEStop = 16;
				estopEnclenche(tempoVerifEStop);			
			}			
			if(ReadBit(estopUtilisateur)==0){	//  vrifier le sens pour tre en dfaut
				tempoVerifEStop = 17;			
				estopEnclenche(tempoVerifEStop);			
			}	
		
			if(ReadBit(lsRideau1)==1){	//  vrifier le sens pour tre en dfaut
				tempoVerifEStop = 20;			
				estopEnclenche(tempoVerifEStop);			
			}	
			if(ReadBit(lsRideau2)==1){	//  vrifier le sens pour tre en dfaut
				tempoVerifEStop = 21;			
				estopEnclenche(tempoVerifEStop);			
			}
			
			if(ReadBit(eStopHmi)==0){	//  vrifier le sens pour tre en dfaut
				tempoVerifEStop = 47;			
				estopEnclenche(tempoVerifEStop);	
*/
	
/*	
	if(ReadBit(eStopHmi)==1){	//  vrifier le sens pour tre en dfaut
		tempoVerifEStop = 47;			
		estopEnclenche(tempoVerifEStop);			
	}	
*/
}

void lectureStatus (int choixAxeStatus)
{
	axeProblematiqueStatus = choixAxeStatus;
	threadActiveStatus = ThreadActive;
	etatCStatus = etatC;
	etatEStatus = etatE;
	etatAStatus = etatA;
	etatMStatus = etatM;
	snapAmpStatus =ReadSnapAmp(SNAP0+SNAP_STATUS);	
}


main()
{
	ecrire4Bits (1, 2000);	// on ecrit 1 comme ligne de depart
	ecrire4Bits (10, 2010);  // on ecrit 10 comme ligne de fin	
	ScreenScript("SScript:PAL-XPSAFv1-principale.scr");	
	//configAxes(); cela se fait maintenant avec un programme c  part et caller dans bios vers principale
	calculPositions();
	
	InitAux();
	AddKonnect(0,&VirtualBits,VirtualBitsEx);
	
	ClearBit(lancerInit);
	ClearBit(etatInit);
	for(;;)  // boucle LOOP
	{
		//resetInit
		if(ReadBit(resetInit)==1)
		{
			ClearBit(resetInit);
			ClearBit(etatInit);
			
			/*
			if(initFaitX == 1){
				initFaitX = 0;			
			}
			if(initFaitY == 1){
				initFaitY = 0;			
			}
			if(initFaitZ == 1){
				initFaitZ = 0;			
			}
			if(initFaitP == 1){
				initFaitP = 0;			
			}
			if(initFaitE == 1){
				initFaitE = 0;			
			}
			*/
		}
		
		if(checkDoneFinPalette == 1)	// fin de la palette
		{
			if((CheckDone(0))&&(CheckDone(1))&&(CheckDone(2))&&(CheckDone(3))&&(etatMoveZ == 0))
			{
				checkDoneFinPalette = 0;
				ecrire4Bits (1, 2000);	// on ecrit 1 comme ligne de depart
				ecrire4Bits (10, 2010);  // on ecrit 10 comme ligne de fin	
				printf ( "checkdoneFinPalette On\n");
				estopEnclenche(-1);
			}
		}
		
				
		encodeurZ ();
		if (etatMoveZ ==1)
		{
			verifierFinDeplacementZ ();
		}
		
		
		if(ReadBit(enFonctionnement)==1)  // boucle de fonctionnement
		{
			/*
			if ((ch0->Enable)==0) 
			{
				lectureStatus(0);											
				estopEnclenche(0);
			}			
			if ((ch1->Enable)==0) 
			{
				lectureStatus(1);										
				estopEnclenche(1);
			}
			if ((ch2->Enable)==0) 
			{
				lectureStatus(2);											
				estopEnclenche(2);	
			}	
			if ((ch3->Enable)==0) 
			{
				lectureStatus(3);												
				estopEnclenche(3);		
			}			
			*/
			g20191120();
			gAplanisseur();
			gElevateur();
			gChariot();
		}else{
			resetEtat();
		}	


	verifModuleEstop ();



	}	// for ou LOOP

	
}	// main

